Index: cprs/trunk/CPRS-Chart/Orders/fODBBank.pas
===================================================================
--- cprs/trunk/CPRS-Chart/Orders/fODBBank.pas	(revision 829)
+++ cprs/trunk/CPRS-Chart/Orders/fODBBank.pas	(revision 1679)
@@ -3325,4 +3536,5 @@
 begin
   inherited;
+  memDiagComment.Text := StringReplace(memDiagComment.Text,CRLF,'  ',[rfReplaceAll]);
   if (length(memDiagComment.Text) > 250) then
     begin
@@ -3353,4 +3565,10 @@
 end;
 
+procedure TfrmODBBank.FormShow(Sender: TObject);
+begin
+  inherited;
+  pgeProduct.SetFocus;
+end;
+
 procedure TfrmODBBank.btnRemoveClick(Sender: TObject);
 var
@@ -3358,5 +3576,5 @@
   x, aName, aModifier, aReason, aTypeScreen: string;
   aList: TStringList;
-  aSel, aSelTst : boolean;
+  aSel, aSelTst, aSelComp, aGotTNS : boolean;
 begin
   inherited;
@@ -3369,4 +3587,6 @@
     aSel := false;
     aSelTst := false;
+    aSelComp := false;
+    aGotTNS := false;
     ExtractTypeScreen(aList, uVBECList);
     if aList.Count > 0 then aTypeScreen := aList[0];
@@ -3381,4 +3601,6 @@
     cboAvailComp.ItemIndex := -1;
     tQuantity.Text := '';
+    tQuantity.Enabled := false;
+    lblQuantity.Enabled := false;
     cboAvailTest.ItemIndex := -1;
     uGetTnS := 0;
@@ -3398,14 +3620,4 @@
                   if lvSelectionList.Items[i].SubItems[3] = piece(uSelectedItems[j],'^',2) then
                     begin
-                      {if (uGetTnS = 1) and (lvSelectionList.Items[i].SubItems[3] = aTypeScreen) then
-                        begin
-                          uGetTnS := 1;
-                          lblTNS.Caption := 'TYPE+SCREEN must be added to order';
-                          lblTNS.Visible := true;
-                          memMessage.Text := 'TYPE + SCREEN must be added to order';
-                          //memMessage.Visible := true;
-                          pnlMessage.Visible := true;
-                          pnlDiagnosticTests.Caption := 'Diagnostic Tests*';
-                        end; }
                       uSelectedItems.Delete(j);
                       lvSelectionList.Items[i].Delete;
@@ -3415,19 +3627,29 @@
           end;
       end;
-    for i := uSelectedItems.Count - 1 downto 0 do
-      begin
-        if (not(piece(uSelectedItems[i],'^',1) = '1')) and (uTNSOrders.Count < 1) then // and (SpecimenNeeded(aList, uVBECList, StrToInt(piece(uSelectedItems[i],'^',9)))) then
+    for i := lvSelectionList.Items.Count - 1 downto 0 do
+      begin
+        if lvSelectionList.Items[i].SubItems[3] = aTypeScreen then
           begin
-            uGetTnS := 1;
-            lblTNS.Caption := 'TYPE+SCREEN must be added to order';
-            lblTNS.Visible := true;
-            memMessage.Text := 'TYPE + SCREEN must be added to order';
-            //memMessage.Visible := true;
-            pnlMessage.Visible := true;
-            pnlDiagnosticTests.Caption := 'Diagnostic Tests*';
+            aGotTNS := true;
             break;
           end;
       end;
-      
+    if aGotTNS = false then
+      begin
+        for i := uSelectedItems.Count - 1 downto 0 do
+          begin
+            if not(piece(uSelectedItems[i],'^',1) = '1') and (uTNSOrders.Count < 1) and (piece(uSelectedItems[i],'^',5) = '1') then //CQ 17349
+              begin
+                uGetTnS := 1;
+                lblTNS.Caption := 'TYPE + SCREEN must be added to order';
+                lblTNS.Visible := true;
+                memMessage.Text := 'TYPE + SCREEN must be added to order';
+                pnlMessage.Visible := true;
+                pnlDiagnosticTests.Caption := 'Diagnostic Tests*';
+                break;
+              end
+              else pnlDiagnosticTests.Caption := 'Diagnostic Tests';
+          end;
+      end;
     if (aSel = false) and (lvSelectionList.Items.Count > 0) then
       begin
@@ -3436,14 +3658,34 @@
       end;
     Responses.Clear;
+    pnlDiagnosticTests.Caption := 'Diagnostic Tests';
+    lblCollTime.Caption := 'Collection Date/Time';
+    lblCollType.Caption := 'Collection Type';
+    lblQuantity.Caption := 'Quantity';
+    lblWanted.Caption := 'Date/Time Wanted';
+    lblReason.Caption := 'Reason for Request';
     if lvSelectionList.Items.Count < 1 then
       begin
-        cboReasons.ItemIndex := -1;
-        memDiagComment.Text := '';
-        cboSurgery.ItemIndex := -1;
-        cboUrgency.ItemIndex := -1;
+        uGetTnS := 0;
+        lblTNS.Caption := '';
+        lblTNS.Visible := false;
+        memMessage.Text := '';
+        pnlMessage.Visible := false;
+        FLastItemID := '';
+        InitDialog;
+        cboModifiers.ItemIndex := -1;
+        cboAvailTest.ItemIndex := -1;
+        cboAvailComp.ItemIndex := -1;
         cboCollType.ItemIndex := -1;
         cboCollTime.ItemIndex := -1;
         cboQuick.ItemIndex := -1;
-        calCollTime.Text := '';
+        calWantTime.Text := '';
+        GroupBox1.Visible := true;
+        tQuantity.Text := '';
+        FLastCollType := '';
+        FLastCollTime := '';
+        FLastLabCollTime := '';
+        txtImmedColl.Text := '';
+        calCollTime.text := '';
+        lblNoBloodReq.Visible := false;
       end;
     for i := 0 to uSelectedItems.Count - 1 do
@@ -3454,4 +3696,6 @@
           begin
             if Length(piece(x,'^',2)) > 0 then Responses.Update('ORDERABLE', CurAdd, piece(x,'^',2), aName);
+            lblCollTime.Caption := 'Collection Date/Time*';
+            lblCollType.Caption := 'Collection Type*';
             aSelTst := true;
           end
@@ -3465,4 +3709,8 @@
             cboAvailComp.ItemIndex := -1;
             tQuantity.Text := '';
+            lblQuantity.Caption := 'Quantity*';
+            lblWanted.Caption := 'Date/Time Wanted*';
+            lblReason.Caption := 'Reason for Request*';
+            //aSelComp := true;
           end;
         Inc(CurAdd);
@@ -3474,4 +3722,8 @@
         calCollTime.Text := '';
       end;
+    {if aSelcomp = false then
+      lblNoBloodReq.Visible := false
+    else
+      lblNoBloodReq.Visible := true;  }
     if Length(calWantTime.Text) > 0 then Responses.Update('DATETIME',1,ValidCollTime(calWantTime.Text),calWantTime.Text);
     if cboCollType.ItemID = 'LC' then
@@ -3569,4 +3821,5 @@
   memMessage.Text := '';
   pnlMessage.Visible := false;
+  FLastItemID := '';
   InitDialog;
   cboModifiers.ItemIndex := -1;
@@ -3583,8 +3836,18 @@
   GroupBox1.Visible := true;
   tQuantity.Text := '';
+  tQuantity.Enabled := false;
+  lblQuantity.Enabled := false;
   FLastCollType := '';
   FLastCollTime := '';
   FLastLabCollTime := '';
   txtImmedColl.Text := '';
+  calCollTime.text := '';
+  lblNoBloodReq.Visible := false;
+  pnlDiagnosticTests.Caption := 'Diagnostic Tests';
+  lblCollTime.Caption := 'Collection Date/Time';
+  lblCollType.Caption := 'Collection Type';
+  lblQuantity.Caption := 'Quantity';
+  lblWanted.Caption := 'Date/Time Wanted';
+  lblReason.Caption := 'Reason for Request';
 end;
 
@@ -3622,16 +3885,27 @@
 
 procedure TfrmODBBank.calWantTimeChange(Sender: TObject);
-begin
-  inherited;
+var
+  i: integer;
+  aList: TStringList;
+  aSpecimen, aSpecimenUID, aSpecimenReq: string;
+  aChanging: Boolean;
+begin
+  inherited;
+  aList := TStringList.Create;
+  aChanging := changing;
+  try
+  aSpecimen := '';
+  aSpecimenUID := '';
+  aSpecimenReq := '';
   if uSelectedItems.Count > 0 then
     begin
-      with calWantTime do if not Changing then
+      with calWantTime do if not changing then
         begin
           if FMDateTime = 0 then
             begin
               ShowMsg('Invalid Date/Time entered');
-              Changing := true;
+              changing := true;
               calWantTime.Text := '';
-              Changing := false;
+              changing := aChanging;
               Exit;
             end
@@ -3642,7 +3916,7 @@
                 begin
                   ShowMsg('Date/Time Wanted must be a future Date/Time');
-                  Changing := true;
+                  changing := true;
                   calWantTime.Text := '';
-                  Changing := false;
+                  changing := aChanging;
                   Exit;
                 end;
@@ -3651,4 +3925,44 @@
       if Length(calWantTime.Text) > 0 then Responses.Update('DATETIME',1,ValidCollTime(calWantTime.Text),calWantTime.Text);
       memOrder.Text := Responses.OrderText;
+      aList.Clear;
+      ExtractSpecimen(aList, uVBECList);
+      if aList.Count > 0 then
+      begin
+        aSpecimen := piece(aList[0], '^', 1);
+        aSpecimenUID := piece(aList[0], '^', 2);
+      end;
+      aList.Clear;
+      ExtractSpecimens(aList, uVBECList);    //Get specimen values to pass back to Server
+      for i := 0 to aList.Count - 1 do
+        begin
+          if (StrToInt(piece(aList[i],'^',1)) = aLabTest.ItemID) then
+            begin
+              aSpecimenReq := piece(aList[i],'^',2);
+              if (SpecimenNeeded(aList, uVBECList, aLabTest.ItemID)) then
+                aSpecimenUID := '';
+              break;
+            end;
+        end;
+      Responses.Update('SPECSTS', 1, aSpecimenReq + '^' + aSpecimen + '^' + aSpecimenUID, aSpecimenReq);
+    end;
+  finally
+    aList.Free;
+  end;
+end;
+
+procedure TfrmODBBank.calWantTimeEnter(Sender: TObject);
+var
+  j: integer;
+begin
+  inherited;
+  if Length(cboAvailComp.Text) > 0 then Exit;
+  for j := uSelectedItems.Count - 1 downto 0 do
+    begin
+      if not(lvSelectionList.Items[j] = nil) and (piece(uSelectedItems[j],'^',1) = '0') then
+        begin
+          lvSelectionList.Items[j].Selected := true;
+          lvSelectionListClick(self);
+          Break;
+        end;
     end;
 end;
@@ -3679,9 +3993,18 @@
       else
         begin
-          lblSurgery.Enabled := false;
-          cboSurgery.Enabled := false;
-          lblSurgery.Caption := 'Surgery';
-          cboSurgery.ItemIndex := -1;
-          Responses.Update('MISC',1,cboSurgery.Text,cboSurgery.Text);
+          if Length(cboSurgery.Text) > 0 then
+            begin
+              lblSurgery.Enabled := true;
+              cboSurgery.Enabled := true;
+              lblSurgery.Caption := 'Surgery*';
+            end
+            else
+            begin
+              lblSurgery.Enabled := false;
+              cboSurgery.Enabled := false;
+              lblSurgery.Caption := 'Surgery';
+              cboSurgery.ItemIndex := -1;
+              Responses.Update('MISC',1,cboSurgery.Text,cboSurgery.Text);
+            end;
         end;
     end
@@ -3700,14 +4023,38 @@
 procedure TfrmODBBank.cboSurgeryChange(Sender: TObject);
 var
-  aList: TStringList;
+  aList, bList, cList: TStringList;
   i,j,aMSBOS,aMSBOSContinue: integer;
-  x: string;
-  handled: boolean;
-begin
-  inherited;
+  x,aTypeScreen: string;
+  handled,aGotTNS: boolean;
+  xLabTest: TLabTest;
+begin
+  inherited;
+  cboSurgery.Text := StringReplace(cboSurgery.Text,CRLF,'  ',[rfReplaceAll]);
   aList := TStringList.Create;
+  bList := TStringList.Create;
+  cList := TStringList.Create;
   handled := false;
+  //uGetTNS := 0;
+  //aGotTNS := false;
+  ExtractTypeScreen(aList, uVBECList);
+  if aList.Count > 0 then aTypeScreen := aList[0];
+  aList.Clear;
+  bList.Clear;
+  cList.Clear;
   try
-    if (Length(cboSurgery.ItemID) > 0) and (Length(tQuantity.Text) > 0) then
+    cboSurgery.DroppedDown := false;
+    if (Length(cboSurgery.ItemID) > 0) then
+      begin
+        for j := 0 to uSelectedItems.Count - 1 do
+          begin
+            xLabTest := TLabTest.Create(piece(uSelectedItems[j],'^',2), Responses);
+            if (piece(uSelectedItems[j],'^',1) = '0') and (not(piece(uSelectedItems[j],'^',3)='')) and (StrToInt(piece(uSelectedItems[j],'^',3)) > 0) and (piece(cboSurgery.Items[cboSurgery.ItemIndex],'^',3) = '1') then
+              begin
+                cList.Add(xLabTest.TestName + '^' + piece(uSelectedItems[j],'^',3));
+              end;
+            xLabTest.Free;
+          end;
+      end;
+    if (Length(cboSurgery.ItemID) > 0) and (Length(tQuantity.Text) > 0) and (Length(cboAvailComp.Text) > 0) then
       begin
         aList.Clear;
@@ -3716,30 +4063,10 @@
           begin
             if (StrToInt(piece(aList[i],'^',1)) = aLabTest.ItemID)
-             and (piece(aList[i],'^',3) = cboSurgery.Text) then
+             and (uppercase((piece(aList[i],'^',3))) = uppercase(cboSurgery.Text)) then
               begin
                 aMSBOS := StrToInt(piece(aList[i],'^',4));
                 if (aMSBOS > 0) and (StrToInt(tQuantity.Text) > aMSBOS) then
                   begin
-                    with Application do
-                    begin
-                      NormalizeTopMosts;
-                      aMSBOSContinue :=
-                        MessageBox(PChar('The number of unit Quantity selected (' + tQuantity.Text +
-                                   ') for ' + aLabTest.TestName + ' exceeds the maximum number of units ('
-                                   + IntToStr(aMSBOS) +
-                                   ') for the ' + cboSurgery.text +
-                                   ' surgical procedure selected.' + CRLF + CRLF + 'Continue to order ' + tQuantity.Text + ' units?'),
-                                   PChar('Maximum Number of Units Exceeded'),
-                                   MB_YESNO);
-                      RestoreTopMosts;
-                    end;
-                    if aMSBOSContinue = 7 then
-                      begin
-                        ShowMsg('Please enter a new quantity for ' + cboAvailComp.Text);
-                        tQuantity.Text := '0';
-                        tQuantity.SelLength := 2;
-                        tQuantity.SelectAll;
-                        break;
-                      end;
+                    bList.Add(aLabTest.TestName + '^' + tQuantity.Text + '^' + IntToStr(aMSBOS));
                   end;
                 handled := true;
@@ -3754,44 +4081,109 @@
         for j := 0 to uSelectedItems.Count - 1 do
           begin
-            ALabTest := TLabTest.Create(piece(uSelectedItems[j],'^',2), Responses);
+            xLabTest := TLabTest.Create(piece(uSelectedItems[j],'^',2), Responses);
             for i := 0 to aList.Count - 1 do
               begin
                 if (piece(uSelectedItems[j],'^',1) = '0')
-                 and (StrToInt(piece(aList[i],'^',1)) = aLabTest.ItemID)
-                 and (piece(aList[i],'^',3) = cboSurgery.Text) then
+                 and (StrToInt(piece(aList[i],'^',1)) = xLabTest.ItemID)
+                 and (uppercase((piece(aList[i],'^',3))) = uppercase(cboSurgery.Text)) then
                   begin
                     aMSBOS := StrToInt(piece(aList[i],'^',4));
                     if (aMSBOS > 0) and (length(piece(uSelectedItems[j],'^',3)) > 0) and (StrToInt(piece(uSelectedItems[j],'^',3)) > aMSBOS) then
                       begin
-                        with Application do
-                        begin
-                          NormalizeTopMosts;
-                          aMSBOSContinue :=
-                            MessageBox(PChar('The number of unit Quantity selected (' + piece(uSelectedItems[j],'^',3) +
-                               ') for ' + lvSelectionList.Items[j].Caption + ' exceeds the maximum number of units ('
-                               + IntToStr(aMSBOS) +
-                               ') for the ' + cboSurgery.text +
-                               ' surgical procedure selected.' + CRLF + CRLF + 'Continue to order ' + piece(uSelectedItems[j],'^',3) + ' units?'),
-                               PChar('Maximum Number of Units Exceeded'),
-                               MB_YESNO);
-                          RestoreTopMosts;
-                        end;
-                        if aMSBOSContinue = 7 then
-                          begin
-                            ShowMsg('Please enter a new quantity for ' + lvSelectionList.Items[j].Caption);
-                            tQuantity.Text := '0';
-                            tQuantity.SelLength := 2;
-                            tQuantity.SelectAll;
-                            x := uSelectedItems[j];
-                            SetPiece(x,U,3,'');
-                            uSelectedItems[j] := x;
-                            lvSelectionList.Items[j].SubItems[0] := '';
-                            RePaint;
-                            break;
-                          end;
+                        bList.Add(xLabTest.TestName + '^' + piece(uSelectedItems[j],'^',3) + '^' + IntToStr(aMSBOS));
                       end;
                     break;
                   end;
               end;
+            xLabTest.Free;
+          end;
+      end;
+    if (uChangingMSBOS = false) and (cList.Count > 0) then
+      begin
+        lblNoBloodReq.Visible := true;
+        with Application do
+          begin
+            NormalizeTopMosts;
+            aMSBOSContinue :=
+              MessageBox(PChar('No blood is required for the surgical procedure: ' + cboSurgery.text +
+               '.' + CRLF +
+               'If you still need to order any components, please enter a justification in the Comment box.'
+                + CRLF + CRLF + 'Do you want me to remove ALL the component orders you''ve just entered? '),
+               PChar('No Blood Required'),MB_YESNO);
+            RestoreTopMosts;
+          end;
+        if aMSBOSContinue = 6 then
+          begin
+            tQuantity.Text := '';
+            bList.Clear;
+            for j := uSelectedItems.Count - 1 downto 0 do
+              begin
+                if not(lvSelectionList.Items[j] = nil) and (piece(uSelectedItems[j],'^',1) = '0') then
+                  begin
+                    lvSelectionList.Items[j].Delete;
+                    uSelectedItems.Delete(j);
+                    Responses.Update('ORDERABLE', (j+1) ,'', '');
+                    Responses.Update('MODIFIER', (j+1), '', '');
+                    Responses.Update('QTY', (j+1), '', '');
+                  end;
+              end;
+            cboAvailComp.Text := '';
+            cboAvailComp.ItemIndex := -1;
+            cboModifiers.Text := '';
+            cboModifiers.ItemIndex := -1;
+            lblNoBloodReq.Visible := false;
+            //if fODBBank. Active then cboAvailTest.SetFocus;
+            lblTNS.Caption := '';
+            lblTNS.Visible := false;
+            uGetTNS := 0;
+            aGotTNS := false;
+            DisableComponentControls;
+            for i := lvSelectionList.Items.Count - 1 downto 0 do
+              begin
+                if lvSelectionList.Items[i].SubItems[3] = aTypeScreen then
+                  begin
+                    aGotTNS := true;
+                    break;
+                  end;
+              end;
+            for i := uSelectedItems.Count - 1 downto 0 do
+              begin
+                if (aGotTNS = false) and not(piece(uSelectedItems[i],'^',1) = '1') and (uTNSOrders.Count < 1) and (piece(uSelectedItems[i],'^',5) = '1') then //CQ 17349
+                  begin
+                    uGetTnS := 1;
+                    lblTNS.Caption := 'TYPE + SCREEN must be added to order';
+                    lblTNS.Visible := true;
+                    memMessage.Text := 'TYPE + SCREEN must be added to order';
+                    pnlMessage.Visible := true;
+                    pnlDiagnosticTests.Caption := 'Diagnostic Tests*';
+                    break;
+                  end
+                  else pnlDiagnosticTests.Caption := 'Diagnostic Tests';
+              end;
+          end;
+      end
+      else
+        begin
+          lblNoBloodReq.Visible := false;
+        end;
+
+    if (uChangingMSBOS = false) and (bList.Count > 0) then
+      begin
+        x := '';
+        for i := 0 to bList.Count - 1 do
+          begin
+            x := x + CRLF + piece(bList[i],'^',1) + ' (' + piece(bList[i],'^',2) + ') Max allowed: ' + piece(bList[i],'^',3);
+          end;
+        with Application do
+          begin
+            NormalizeTopMosts;
+            aMSBOSContinue :=
+              MessageBox(PChar('The number of units ordered' + x + CRLF +
+               'Exceeds the maximum number recommended for '
+               + cboSurgery.text + CRLF + CRLF +
+               'If you need to order more than the recommended maximum units, please enter a justification in the Comment box.')
+               ,PChar('Maximum Number of Units Exceeded'),
+               MB_OK);
+            RestoreTopMosts;
           end;
       end;
@@ -3806,7 +4198,9 @@
         Responses.Update('REASON',1,cboReasons.Text,cboReasons.Text);
       end;
-    memOrder.Text := Responses.OrderText; 
+    memOrder.Text := Responses.OrderText;
     finally
       aList.Free;
+      bList.Free;
+      cList.Free;
     end;
 end;
@@ -3844,6 +4238,9 @@
     end;
   try
-    if (Length(cboSurgery.ItemID) > 0) and (Length(tQuantity.Text) > 0) then
-      begin
+    if not(aLabTest = nil) and (Length(cboSurgery.ItemID) > 0) and (Length(tQuantity.Text) > 0) then
+      begin
+        uChangingMSBOS := true;
+        cboSurgeryChange(self);
+        uChangingMSBOS := false;
         aList.Clear;
         ExtractMSBOS(aList, uVBECList);    //Get maximum units for selected Surgery
@@ -3851,5 +4248,5 @@
           begin
             if (StrToInt(piece(aList[i],'^',1)) = aLabTest.ItemID)
-             and (piece(aList[i],'^',3) = cboSurgery.Text) then
+             and (uppercase((piece(aList[i],'^',3))) = uppercase(cboSurgery.Text)) and (Length(tQuantity.Text) > 0) then
               begin
                 aMSBOS := StrToInt(piece(aList[i],'^',4));
@@ -3861,13 +4258,16 @@
                       aMSBOSContinue :=
                         MessageBox(PChar('The number of units ordered (' + tQuantity.Text +
-                                   ') for ' + aLabTest.TestName + ' exceeds the maximum number of units ('
-                                   + IntToStr(aMSBOS) +
-                                   ') for the ' + cboSurgery.text +
-                                   ' surgical procedure selected.' + CRLF + CRLF + 'Do you wish to continue?'),
-                                   PChar('Maximum Number of Units Exceeded'),
-                                   MB_YESNO);
+                         ') for ' + aLabTest.TestName + ' Exceeds the maximum number recommended ('
+                         + IntToStr(aMSBOS) +
+                         ') for the ' + cboSurgery.text +
+                         ' surgical procedure.' + CRLF +
+                         'If you need to order more than the maximum number of units, please enter a justification in the Comment box.'
+                          + CRLF + CRLF + 'Edit the Blood component Quantity?'),
+                         PChar('Maximum Number of Units Exceeded'),
+                         MB_YESNO);
+
                       RestoreTopMosts;
                     end;
-                    if aMSBOSContinue = 7 then
+                    if aMSBOSContinue = 6 then
                       begin
                         ShowMsg('Please enter a new quantity for ' + cboAvailComp.Text);
@@ -3927,8 +4327,37 @@
 
 procedure TfrmODBBank.tQuantityEnter(Sender: TObject);
+var
+  j: integer;
 begin
   inherited;
   tQuantity.SelLength := 2;
   tQuantity.SelectAll;
+  if Length(cboAvailComp.Text) > 0 then Exit;
+  for j := uSelectedItems.Count - 1 downto 0 do
+    begin
+      if not(lvSelectionList.Items[j] = nil) and (piece(uSelectedItems[j],'^',1) = '0') then
+        begin
+          lvSelectionList.Items[j].Selected := true;
+          lvSelectionListClick(self);
+          Break;
+        end;
+    end;
+end;
+
+procedure TfrmODBBank.txtImmedCollEnter(Sender: TObject);
+var
+  j: integer;
+begin
+  inherited;
+  if Length(cboAvailTest.Text) > 0 then Exit;
+  for j := uSelectedItems.Count - 1 downto 0 do
+    begin
+      if not(lvSelectionList.Items[j] = nil) and (piece(uSelectedItems[j],'^',1) = '1') then
+        begin
+          lvSelectionList.Items[j].Selected := true;
+          lvSelectionListClick(self);
+          Break;
+        end;
+    end;
 end;
 
@@ -3970,3 +4399,20 @@
 end;
 
+procedure TfrmODBBank.calCollTimeEnter(Sender: TObject);
+var
+  j: integer;
+begin
+  inherited;
+  if Length(cboAvailTest.Text) > 0 then Exit;
+  for j := uSelectedItems.Count - 1 downto 0 do
+    begin
+      if not(lvSelectionList.Items[j] = nil) and (piece(uSelectedItems[j],'^',1) = '1') then
+        begin
+          lvSelectionList.Items[j].Selected := true;
+          lvSelectionListClick(self);
+          Break;
+        end;
+    end;
+end;
+
 end.
